



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Fractal Tree</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Fractal Tree</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 21:52:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>尝试使用递归方式实现一棵简单的分形树，给出初始点的坐标，在此基础上根据坐标轴旋转的规则计算出子树干与根节点的坐标关系，依次递归画出左子树干和右子树干，并提供一个递归的深度用于控制画的子树的数目。</p>
<p>在二维坐标系中，坐标轴旋转的公式如下：</p>
<p>In two dimensions, every rotation matrix has the following form,</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/685583/201501/052231491876466.png" /></p>
<p>This rotates <a href="http://en.wikipedia.org/wiki/Column_vector" rel="external nofollow noreferrer">column vectors</a> by means of the following <a href="http://en.wikipedia.org/wiki/Matrix_multiplication" rel="external nofollow noreferrer">matrix multiplication</a>,</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/685583/201501/052232070466409.png" /></p>
<p>So the coordinates (<em>x',y'</em>) of the point (<em>x,y</em>) after rotation are</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/685583/201501/052232226091956.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/685583/201501/052233002967741.png" /></p>
<p>参考资料见维基百科旋转矩阵：<a href="http://en.wikipedia.org/wiki/Rotation_matrix" rel="external nofollow noreferrer">http://en.wikipedia.org/wiki/Rotation_matrix</a></p>
<p>将这个分形树的实现添加到之前的绘图框架中，只需要增加一个Tree1类，然后再FractalPanel中调用此类的draw方法即可，并且在FractalMain类中添加相关的Button操作。Tree1类的实现如下：</p>
<div>
<pre class="prettyprint linenums">package com.elvalad;

import java.awt.*;

/**<br />
 * Created by elvalad on 2015/1/4.<br />
 */<br />
public class Tree1 {<br />
    private double x;<br />
    private double y;<br />
    private double alpha;<br />
    private int depth;<br />
    private Color color = new Color(43, 77, 219);

    public Tree1(double x, double y, double alpha, int depth, Color color) {<br />
        this.x = x;<br />
        this.y = y;<br />
        this.alpha = alpha;<br />
        this.depth = depth;<br />
        this.color = color;<br />
    }

    public void draw(Graphics g) {<br />
        g.setColor(this.color);<br />
        this.drawShape(g, this.x, this.y, this.alpha, this.depth);<br />
    }

    private void drawShape(Graphics g, double x1, double y1, double angle, double depth) {<br />
        if (depth == 0) {<br />
        } else {<br />
            double x2 = x1 + Math.cos(Math.toRadians(angle)) * depth * 15.0;<br />
            double y2 = y1 + Math.sin(Math.toRadians(angle)) * depth * 15.0;

            Graphics2D g2d = (Graphics2D) g;<br />
            g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,     RenderingHints.VALUE_ANTIALIAS_ON);<br />
            g2d.setStroke(new BasicStroke((float) (0.5f * depth)));<br />
            g.drawLine((int)x1, (int)y1, (int)x2, (int)y2);

            drawShape(g, x2, y2, angle + 25, depth - 1);<br />
            drawShape(g, x2, y2, angle - 25, depth - 1);<br />
        }<br />
    }<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/685583/201501/052237550932479.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqd45zqd.html">应用层之E-mail服务及javaMail邮件发送的知识总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7knrj9.html">最全面的jdbcUtils，总有一种适合你</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kw1378.html">&lbrack;整理&rsqb;Ajax Post请求下的Form Data和Request Payload</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v4m0j8.html">3d ListView翻译</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnmd5z8.html">Hybrid UI framework shootout&colon; Ionic vs&period; Famo&period;us vs&period; F7 vs&period; OnsenUI</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdv4o8.html">ECOS- 技术问题答疑&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnp0k9.html">用C&num;开发一个 UWP BLUETOOTH BLE 扫描APP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg306d8.html">傅里叶变换 - Fourier Transform</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyko1z9.html">React框架 dva 和 mobx 的使用感受</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodpedq.html">总结：BGP和静态路由并存，达到故障自动倒换的目的。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5d0wmq.html">JavaSE-2018&period;12&period;20更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rppz28.html">CodeForces922E DP&sol;&sol;多重背包的二进制优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4dd3pq.html">U3D功能脚本备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em5d1k9.html">一个Java例子，解释清楚注解的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvx5zdq.html">C&num; 集合类-使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveoylj9.html">Android开发16&mdash;&mdash;获取网络资源之基础应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2gx5v8.html">20145326《Java程序设计》第二周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppl1g49.html">Android 通过浏览器打开应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xjj4v9.html">HashMap、HashTable的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77e5wxq.html">hive 优化</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wwnmlq.html">robotframework笔记10</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yy230q.html">win7下安装MYSQL报错：&amp;quot&semi;MYSQL 服务无法启动&amp;quot&semi;的3534问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vv5548.html">简单springMVC环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyddj3dq.html">Css3动画缩放</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z11zpv9.html">easyui datagrid 学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvvyy1q.html">oracle优化原则&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmm4ok9.html">PHP 页面编码声明方法详解&lpar;header或meta&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnnvze8.html">BZOJ1747 &lbrack;Usaco2005 open&rsqb;Expedition 探险</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vv6o48.html">spring mvc上传图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zz0z09.html">微信浏览器&mdash;&mdash;User Agent</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
